unit ESDFP_strings;

interface

uses sysutils, classes;

type
     TPARAMLIST = class
        private
                m_strings:TStringlist;

                procedure seperateParamFromValue(originalstring:string;var parametername,parametervalue:string);

                procedure getParameterIndex(paramname:string; var index:integer);

                procedure addParameter(paramname,value:string);

        public
                constructor Create();
                destructor Destroy();override;

                procedure addESDF_P_string(ESDF_P_string:string);
                function getParameter(paramname,defaultvalue:string):string;
      end;

implementation

constructor TPARAMLIST.Create();
begin
        inherited Create();

        m_strings:=TStringList.Create();
end;

destructor TPARAMLIST.Destroy();
var i:integer;
begin
        for i:=1 to m_strings.Count do
         begin
                m_strings[i-1]:='';
         end;

        m_strings.Destroy();

        inherited Destroy();
end;

procedure TPARAMLIST.addParameter(paramname,value:string);
var index:integer;
begin
        getParameterIndex(paramname, index);
        if index<>-1 then
        begin
                m_strings[index]:=paramname+'='+value;
        end
        else
        begin
                m_strings.Add(paramname+'='+value);
        end;
       
end;

procedure TPARAMLIST.getParameterIndex(paramname:string; var index:integer);
var i:integer;
    parametername, parametervalue:string;
begin
        i:=1;
        while (i<=m_strings.Count) do
         begin
                seperateParamFromValue(m_strings[i-1],parametername, parametervalue);
                if paramname=parametername then
                 begin
                        index:=i-1;
                        exit;
                 end;
                inc(i);
         end;

         index:=-1;
end;

procedure TPARAMLIST.seperateParamFromValue(originalstring:string;var parametername,parametervalue:string);
var i:integer;
begin
        i:=AnsiPos('=',originalstring);

        if i=0 then raise Exception.Create(originalstring+' is not a valid SDF-P string');

        parametername:=copy(originalstring, 1, i-1);
        parametervalue:=copy(originalstring, i+1, length(originalstring)-i+1);
end;

procedure TPARAMLIST.addESDF_P_string(ESDF_P_string:string);
var parametername, parametervalue:string;
    oldparametername, oldparametervalue:string;
    m_tempstringlist:TStringlist;
    i,index:integer;
begin
        m_tempstringlist:=TStringlist.Create();

        try
                try
                        m_tempstringlist.Commatext:=ESDF_P_string;
                        for i:=1 to m_tempstringlist.Count do
                         begin
                                seperateParamFromValue(m_tempstringlist[i-1],parametername,parametervalue);
                                if copy(parametername, length(parametername),1)='+' then
                                 begin
                                        getParameterIndex(copy(parametername, 1, length(parametername)-1), index);
                                        if index<>-1 then
                                         begin
                                                seperateParamFromValue(m_strings[index],oldparametername,oldparametervalue);
                                                m_strings[index]:=oldparametername+'='+oldparametervalue+parametervalue;
                                         end
                                         else
                                         begin
                                                addParameter(parametername, parametervalue);
                                         end;
                                 end
                                 else
                                 begin
                                        addParameter(parametername, parametervalue);
                                 end;
                         end;

                except
                        on E: Exception do raise Exception.Create('invalid ESDF-P string ('+ESDF_P_string+')');
                end;
        finally
                m_tempstringlist.Destroy();
        end;
end;

function TPARAMLIST.getParameter(paramname,defaultvalue:string):string;
var i:integer;
    m_parametername, m_parametervalue:string;
begin
        getParameterIndex(paramname,i);
        if i<>-1 then
         begin
                seperateParamFromValue(m_strings[i],m_parametername, m_parametervalue);
                result:=m_parametervalue;
         end
         else
                result:=defaultvalue;
         begin
         end;
end;

end.
